/*
 * This file was generated - do not edit it directly !!
 * Generated by AuDAO tool, a product of Spolecne s.r.o.
 * For more information please visit http://www.spoledge.com
 */
package com.spoledge.audao.web.db.dao.gae;


import java.sql.Date;
import java.sql.Timestamp;

import java.util.ArrayList;

import com.google.appengine.api.datastore.DatastoreService;
import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.datastore.Query;


import com.spoledge.audao.db.dao.gae.GaeAbstractDaoImpl;
import com.spoledge.audao.db.dao.DBException;
import com.spoledge.audao.db.dao.DaoException;


import com.spoledge.audao.web.db.dao.RegisteredUserDao;
import com.spoledge.audao.web.db.dto.RegisteredUser;


/**
 * This is the DAO imlementation class.
 *
 * @author generated
 */
public class RegisteredUserDaoImpl extends GaeAbstractDaoImpl<RegisteredUser> implements RegisteredUserDao {

    private static final String TABLE_NAME = "RegisteredUser";

    public RegisteredUserDaoImpl( DatastoreService ds ) {
        super( ds );
    }

    /**
     * Finds a record identified by its primary key.
     * @return the record found or null
     */
    public RegisteredUser findByPrimaryKey( long userId ) {
        Entity _ent = entityGet( new KeyFactory.Builder( "RegisteredUser", userId ).getKey());

        return _ent != null ? fetch( null, _ent ) : null;
    }

    /**
     * Finds a record.
     */
    public RegisteredUser findByGaeUserId( String gaeUserId ) {
        Query _query = getQuery();
        _query.addFilter( "gaeUserId", Query.FilterOperator.EQUAL, gaeUserId );

        return findOne( _query, "gaeUserId = :1", 0, gaeUserId);
    }

    /**
     * Inserts a new record.
     * @return the generated primary key - userId
     */
    public long insert( RegisteredUser dto ) throws DaoException {
        Entity _ent = new Entity( "RegisteredUser");

        {
            if ( dto.getGaeUserId() == null ) {
                throw new DaoException("Value of column 'gae_user_id' cannot be null");
            }
            checkMaxLength( "gae_user_id", dto.getGaeUserId(), 500 );
            _ent.setProperty( "gaeUserId", dto.getGaeUserId());

            if ( dto.getUserName() == null ) {
                throw new DaoException("Value of column 'user_name' cannot be null");
            }
            checkMaxLength( "user_name", dto.getUserName(), 500 );
            _ent.setProperty( "userName", dto.getUserName());

            if ( dto.getCreatedDate() == null ) {
                dto.setCreatedDate( new Date( System.currentTimeMillis()));
            }
            _ent.setProperty( "createdDate", date( dto.getCreatedDate() ));

            if ( dto.getLastLoginDate() == null ) {
                dto.setLastLoginDate( new Timestamp( System.currentTimeMillis()));
            }
            _ent.setProperty( "lastLoginDate", date( dto.getLastLoginDate() ));
        }

        entityPut( _ent, dto, "insert" );

        dto.setUserId( _ent.getKey().getId());

        return dto.getUserId();
    }

    /**
     * Updates column last_login_date of one record found by primary key.
     * @return true iff the record was really updated (=found)
     */
    public boolean updateLastLoginDate( long userId, Timestamp lastLoginDate ) throws DaoException {
        checkNull( "last_login_date", lastLoginDate );

        Entity _ent = entityGet( new KeyFactory.Builder( "RegisteredUser", userId ).getKey());
        if (_ent == null) return false;

        _ent.setProperty( "lastLoginDate", date( lastLoginDate ));

        entityPut( _ent, lastLoginDate, "updateLastLoginDate" );

        return true;
    }

    /**
     * Returns the table name.
     */
    public String getTableName() {
        return TABLE_NAME;
    }

    protected RegisteredUser fetch( RegisteredUser dto, Entity ent ) {
        if ( dto == null ) dto = new RegisteredUser();

        dto.setUserId( ent.getKey().getId());
        dto.setGaeUserId( getString( ent, "gaeUserId" ));
        dto.setUserName( getString( ent, "userName" ));
        dto.setCreatedDate( getDate( ent, "createdDate" ));
        dto.setLastLoginDate( getTimestamp( ent, "lastLoginDate" ));

        return dto;
    }

    protected RegisteredUser[] toArray(ArrayList<RegisteredUser> list ) {
        RegisteredUser[] ret = new RegisteredUser[ list.size() ];
        return list.toArray( ret );
    }

}
